<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.resolver</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        Module&nbsp;resolver
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyxmpp.resolver-module.html">Module pyxmpp.resolver</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># (C) Copyright 2003-2010 Jacek Konieczny &lt;jajcus@jajcus.net&gt;</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"># it under the terms of the GNU Lesser General Public License Version</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># 2.1 as published by the Free Software Foundation.</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment"># GNU Lesser General Public License for more details.</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># You should have received a copy of the GNU Lesser General Public</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># License along with this program; if not, write to the Free Software</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"><tt class="py-docstring">"""DNS resolever with SRV record support.</tt> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-docstring">Normative reference:</tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"><tt class="py-docstring">  - `RFC 1035 &lt;http://www.ietf.org/rfc/rfc1035.txt&gt;`__</tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-docstring">  - `RFC 2782 &lt;http://www.ietf.org/rfc/rfc2782.txt&gt;`__</tt> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"><tt class="py-docstring">"""</tt> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"><tt class="py-name">__docformat__</tt><tt class="py-op">=</tt><tt class="py-string">"restructuredtext en"</tt> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">re</tt> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt id="link-0" class="py-name" targets="Method pyxmpp.jabberd.component.Component.socket()=pyxmpp.jabberd.component.Component-class.html#socket"><a title="pyxmpp.jabberd.component.Component.socket" class="py-name" href="#" onclick="return doclink('link-0', 'socket', 'link-0');">socket</a></tt> </tt>
<a name="L29"></a><tt class="py-lineno"> 29</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-1" class="py-name"><a title="pyxmpp.jabberd.component.Component.socket" class="py-name" href="#" onclick="return doclink('link-1', 'socket', 'link-0');">socket</a></tt> <tt class="py-keyword">import</tt> <tt class="py-name">AF_UNSPEC</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET6</tt> </tt>
<a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">dns</tt><tt class="py-op">.</tt><tt id="link-2" class="py-name" targets="Module pyxmpp.resolver=pyxmpp.resolver-module.html"><a title="pyxmpp.resolver" class="py-name" href="#" onclick="return doclink('link-2', 'resolver', 'link-2');">resolver</a></tt> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">dns</tt><tt class="py-op">.</tt><tt id="link-3" class="py-name" targets="Variable pyxmpp.all.name=pyxmpp.all-module.html#name,Variable pyxmpp.interfaces.name=pyxmpp.interfaces-module.html#name,Variable pyxmpp.jabber.all.name=pyxmpp.jabber.all-module.html#name,Variable pyxmpp.jabber.disco.DiscoIdentity.name=pyxmpp.jabber.disco.DiscoIdentity-class.html#name,Variable pyxmpp.jabber.disco.DiscoItem.name=pyxmpp.jabber.disco.DiscoItem-class.html#name,Variable pyxmpp.jabberd.all.name=pyxmpp.jabberd.all-module.html#name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-3', 'name', 'link-3');">name</a></tt> </tt>
<a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">dns</tt><tt class="py-op">.</tt><tt class="py-name">exception</tt> </tt>
<a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">random</tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">logging</tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"> </tt>
<a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-op">.</tt><tt id="link-4" class="py-name" targets="Module pyxmpp.exceptions=pyxmpp.exceptions-module.html"><a title="pyxmpp.exceptions" class="py-name" href="#" onclick="return doclink('link-4', 'exceptions', 'link-4');">exceptions</a></tt> <tt class="py-keyword">import</tt> <tt id="link-5" class="py-name" targets="Class pyxmpp.exceptions.DNSError=pyxmpp.exceptions.DNSError-class.html"><a title="pyxmpp.exceptions.DNSError" class="py-name" href="#" onclick="return doclink('link-5', 'DNSError', 'link-5');">DNSError</a></tt><tt class="py-op">,</tt> <tt id="link-6" class="py-name" targets="Class pyxmpp.exceptions.UnexpectedCNAMEError=pyxmpp.exceptions.UnexpectedCNAMEError-class.html"><a title="pyxmpp.exceptions.UnexpectedCNAMEError" class="py-name" href="#" onclick="return doclink('link-6', 'UnexpectedCNAMEError', 'link-6');">UnexpectedCNAMEError</a></tt> </tt>
<a name="L37"></a><tt class="py-lineno"> 37</tt>  <tt class="py-line"> </tt>
<a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line"><tt id="link-7" class="py-name" targets="Variable pyxmpp.resolver.logger=pyxmpp.resolver-module.html#logger,Variable pyxmpp.xmlextra.logger=pyxmpp.xmlextra-module.html#logger"><a title="pyxmpp.resolver.logger
pyxmpp.xmlextra.logger" class="py-name" href="#" onclick="return doclink('link-7', 'logger', 'link-7');">logger</a></tt> <tt class="py-op">=</tt> <tt class="py-name">logging</tt><tt class="py-op">.</tt><tt class="py-name">getLogger</tt><tt class="py-op">(</tt><tt class="py-string">"pyxmpp.resolver"</tt><tt class="py-op">)</tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line"> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line"><tt class="py-comment"># check IPv6 support</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line"><tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line">    <tt id="link-8" class="py-name"><a title="pyxmpp.jabberd.component.Component.socket" class="py-name" href="#" onclick="return doclink('link-8', 'socket', 'link-0');">socket</a></tt><tt class="py-op">.</tt><tt id="link-9" class="py-name"><a title="pyxmpp.jabberd.component.Component.socket" class="py-name" href="#" onclick="return doclink('link-9', 'socket', 'link-0');">socket</a></tt><tt class="py-op">(</tt><tt class="py-name">AF_INET6</tt><tt class="py-op">)</tt> </tt>
<a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line"><tt class="py-keyword">except</tt> <tt id="link-10" class="py-name"><a title="pyxmpp.jabberd.component.Component.socket" class="py-name" href="#" onclick="return doclink('link-10', 'socket', 'link-0');">socket</a></tt><tt class="py-op">.</tt><tt id="link-11" class="py-name" targets="Method pyxmpp.cache.CacheFetcher.error()=pyxmpp.cache.CacheFetcher-class.html#error,Module pyxmpp.error=pyxmpp.error-module.html,Method pyxmpp.jabber.muc.MucRoomHandler.error()=pyxmpp.jabber.muc.MucRoomHandler-class.html#error,Method pyxmpp.streambase.StreamBase.error()=pyxmpp.streambase.StreamBase-class.html#error,Method pyxmpp.xmlextra.StreamHandler.error()=pyxmpp.xmlextra.StreamHandler-class.html#error,Method pyxmpp.xmlextra._SAXCallback.error()=pyxmpp.xmlextra._SAXCallback-class.html#error"><a title="pyxmpp.cache.CacheFetcher.error
pyxmpp.error
pyxmpp.jabber.muc.MucRoomHandler.error
pyxmpp.streambase.StreamBase.error
pyxmpp.xmlextra.StreamHandler.error
pyxmpp.xmlextra._SAXCallback.error" class="py-name" href="#" onclick="return doclink('link-11', 'error', 'link-11');">error</a></tt><tt class="py-op">:</tt> </tt>
<a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line">    <tt id="link-12" class="py-name" targets="Variable pyxmpp.resolver.default_address_family=pyxmpp.resolver-module.html#default_address_family"><a title="pyxmpp.resolver.default_address_family" class="py-name" href="#" onclick="return doclink('link-12', 'default_address_family', 'link-12');">default_address_family</a></tt> <tt class="py-op">=</tt> <tt class="py-name">AF_INET</tt> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line"><tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line">    <tt id="link-13" class="py-name"><a title="pyxmpp.resolver.default_address_family" class="py-name" href="#" onclick="return doclink('link-13', 'default_address_family', 'link-12');">default_address_family</a></tt> <tt class="py-op">=</tt> <tt class="py-name">AF_UNSPEC</tt> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line"> </tt>
<a name="set_default_address_family"></a><div id="set_default_address_family-def"><a name="L48"></a><tt class="py-lineno"> 48</tt> <a class="py-toggle" href="#" id="set_default_address_family-toggle" onclick="return toggle('set_default_address_family');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.resolver-module.html#set_default_address_family">set_default_address_family</a><tt class="py-op">(</tt><tt class="py-param">family</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="set_default_address_family-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="set_default_address_family-expanded"><a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line">    <tt class="py-docstring">"""Select default address family.</tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line"><tt class="py-docstring">      - `family`: `AF_INET` for IPv4, `AF_INET6` for IPv6 and `AF_UNSPEC` for</tt> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line"><tt class="py-docstring">        dual stack."""</tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line">    <tt class="py-keyword">global</tt> <tt id="link-14" class="py-name"><a title="pyxmpp.resolver.default_address_family" class="py-name" href="#" onclick="return doclink('link-14', 'default_address_family', 'link-12');">default_address_family</a></tt> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line">    <tt id="link-15" class="py-name"><a title="pyxmpp.resolver.default_address_family" class="py-name" href="#" onclick="return doclink('link-15', 'default_address_family', 'link-12');">default_address_family</a></tt> <tt class="py-op">=</tt> <tt class="py-name">family</tt> </tt>
</div><a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line"> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line"><tt id="link-16" class="py-name" targets="Variable pyxmpp.resolver.service_aliases=pyxmpp.resolver-module.html#service_aliases"><a title="pyxmpp.resolver.service_aliases" class="py-name" href="#" onclick="return doclink('link-16', 'service_aliases', 'link-16');">service_aliases</a></tt><tt class="py-op">=</tt><tt class="py-op">{</tt><tt class="py-string">"xmpp-server"</tt><tt class="py-op">:</tt> <tt class="py-op">(</tt><tt class="py-string">"jabber-server"</tt><tt class="py-op">,</tt><tt class="py-string">"jabber"</tt><tt class="py-op">)</tt><tt class="py-op">}</tt> </tt>
<a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line"> </tt>
<a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line"><tt class="py-comment"># should match all valid IP addresses, but can pass some false-positives,</tt> </tt>
<a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line"><tt class="py-comment"># which are not valid domain names</tt> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line"><tt id="link-17" class="py-name" targets="Variable pyxmpp.resolver.ipv4_re=pyxmpp.resolver-module.html#ipv4_re"><a title="pyxmpp.resolver.ipv4_re" class="py-name" href="#" onclick="return doclink('link-17', 'ipv4_re', 'link-17');">ipv4_re</a></tt><tt class="py-op">=</tt><tt class="py-name">re</tt><tt class="py-op">.</tt><tt class="py-name">compile</tt><tt class="py-op">(</tt><tt class="py-string">r"^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$"</tt><tt class="py-op">)</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line"><tt id="link-18" class="py-name" targets="Variable pyxmpp.resolver.ipv6_re=pyxmpp.resolver-module.html#ipv6_re"><a title="pyxmpp.resolver.ipv6_re" class="py-name" href="#" onclick="return doclink('link-18', 'ipv6_re', 'link-18');">ipv6_re</a></tt><tt class="py-op">=</tt><tt class="py-name">re</tt><tt class="py-op">.</tt><tt class="py-name">compile</tt><tt class="py-op">(</tt><tt class="py-string">r"^[0-9a-f]{0,4}:[0-9a-f:]{0,29}:([0-9a-f]{0,4}|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})$"</tt><tt class="py-op">)</tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line"> </tt>
<a name="shuffle_srv"></a><div id="shuffle_srv-def"><a name="L64"></a><tt class="py-lineno"> 64</tt> <a class="py-toggle" href="#" id="shuffle_srv-toggle" onclick="return toggle('shuffle_srv');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.resolver-module.html#shuffle_srv">shuffle_srv</a><tt class="py-op">(</tt><tt class="py-param">records</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="shuffle_srv-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="shuffle_srv-expanded"><a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line">    <tt class="py-docstring">"""Randomly reorder SRV records using their weights.</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line"><tt class="py-docstring">        - `records`: SRV records to shuffle.</tt> </tt>
<a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line"><tt class="py-docstring">        - `records`: sequence of `dns.rdtypes.IN.SRV`</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line"><tt class="py-docstring">    :return: reordered records.</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line"><tt class="py-docstring">    :returntype: `list` of `dns.rdtypes.IN.SRV`"""</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">records</tt><tt class="py-op">:</tt> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L76"></a><tt class="py-lineno"> 76</tt>  <tt class="py-line">    <tt class="py-name">ret</tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">    <tt class="py-keyword">while</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">records</tt><tt class="py-op">)</tt><tt class="py-op">&gt;</tt><tt class="py-number">1</tt><tt class="py-op">:</tt> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line">        <tt class="py-name">weight_sum</tt><tt class="py-op">=</tt><tt class="py-number">0</tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">rr</tt> <tt class="py-keyword">in</tt> <tt class="py-name">records</tt><tt class="py-op">:</tt> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line">            <tt class="py-name">weight_sum</tt><tt class="py-op">+=</tt><tt class="py-name">rr</tt><tt class="py-op">.</tt><tt class="py-name">weight</tt><tt class="py-op">+</tt><tt class="py-number">0.1</tt> </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line">        <tt class="py-name">thres</tt><tt class="py-op">=</tt><tt class="py-name">random</tt><tt class="py-op">.</tt><tt class="py-name">random</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">*</tt><tt class="py-name">weight_sum</tt> </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line">        <tt class="py-name">weight_sum</tt><tt class="py-op">=</tt><tt class="py-number">0</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">rr</tt> <tt class="py-keyword">in</tt> <tt class="py-name">records</tt><tt class="py-op">:</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line">            <tt class="py-name">weight_sum</tt><tt class="py-op">+=</tt><tt class="py-name">rr</tt><tt class="py-op">.</tt><tt class="py-name">weight</tt><tt class="py-op">+</tt><tt class="py-number">0.1</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">thres</tt><tt class="py-op">&lt;</tt><tt class="py-name">weight_sum</tt><tt class="py-op">:</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line">                <tt class="py-name">records</tt><tt class="py-op">.</tt><tt id="link-19" class="py-name" targets="Method pyxmpp.jabber.disco.DiscoIdentity.remove()=pyxmpp.jabber.disco.DiscoIdentity-class.html#remove,Method pyxmpp.jabber.disco.DiscoItem.remove()=pyxmpp.jabber.disco.DiscoItem-class.html#remove"><a title="pyxmpp.jabber.disco.DiscoIdentity.remove
pyxmpp.jabber.disco.DiscoItem.remove" class="py-name" href="#" onclick="return doclink('link-19', 'remove', 'link-19');">remove</a></tt><tt class="py-op">(</tt><tt class="py-name">rr</tt><tt class="py-op">)</tt> </tt>
<a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line">                <tt class="py-name">ret</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-name">rr</tt><tt class="py-op">)</tt> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line">                <tt class="py-keyword">break</tt> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line">    <tt class="py-name">ret</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-name">records</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt class="py-name">ret</tt> </tt>
</div><a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line"> </tt>
<a name="reorder_srv"></a><div id="reorder_srv-def"><a name="L92"></a><tt class="py-lineno"> 92</tt> <a class="py-toggle" href="#" id="reorder_srv-toggle" onclick="return toggle('reorder_srv');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.resolver-module.html#reorder_srv">reorder_srv</a><tt class="py-op">(</tt><tt class="py-param">records</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="reorder_srv-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="reorder_srv-expanded"><a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">    <tt class="py-docstring">"""Reorder SRV records using their priorities and weights.</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line"><tt class="py-docstring">        - `records`: SRV records to shuffle.</tt> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line"><tt class="py-docstring">        - `records`: `list` of `dns.rdtypes.IN.SRV`</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line"><tt class="py-docstring">    :return: reordered records.</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line"><tt class="py-docstring">    :returntype: `list` of `dns.rdtypes.IN.SRV`"""</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line">    <tt class="py-name">records</tt><tt class="py-op">=</tt><tt class="py-name">list</tt><tt class="py-op">(</tt><tt class="py-name">records</tt><tt class="py-op">)</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line">    <tt class="py-name">records</tt><tt class="py-op">.</tt><tt class="py-name">sort</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line">    <tt class="py-name">ret</tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line">    <tt class="py-name">tmp</tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line">    <tt class="py-keyword">for</tt> <tt class="py-name">rr</tt> <tt class="py-keyword">in</tt> <tt class="py-name">records</tt><tt class="py-op">:</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">tmp</tt> <tt class="py-keyword">or</tt> <tt class="py-name">rr</tt><tt class="py-op">.</tt><tt class="py-name">priority</tt><tt class="py-op">==</tt><tt class="py-name">tmp</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">.</tt><tt class="py-name">priority</tt><tt class="py-op">:</tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line">            <tt class="py-name">tmp</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-name">rr</tt><tt class="py-op">)</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line">            <tt class="py-keyword">continue</tt> </tt>
<a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line">        <tt class="py-name">ret</tt><tt class="py-op">+=</tt><tt id="link-20" class="py-name" targets="Function pyxmpp.resolver.shuffle_srv()=pyxmpp.resolver-module.html#shuffle_srv"><a title="pyxmpp.resolver.shuffle_srv" class="py-name" href="#" onclick="return doclink('link-20', 'shuffle_srv', 'link-20');">shuffle_srv</a></tt><tt class="py-op">(</tt><tt class="py-name">tmp</tt><tt class="py-op">)</tt> </tt>
<a name="L111"></a><tt class="py-lineno">111</tt>  <tt class="py-line">        <tt class="py-name">tmp</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-name">rr</tt><tt class="py-op">]</tt> </tt>
<a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-name">tmp</tt><tt class="py-op">:</tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line">        <tt class="py-name">ret</tt><tt class="py-op">+=</tt><tt id="link-21" class="py-name"><a title="pyxmpp.resolver.shuffle_srv" class="py-name" href="#" onclick="return doclink('link-21', 'shuffle_srv', 'link-20');">shuffle_srv</a></tt><tt class="py-op">(</tt><tt class="py-name">tmp</tt><tt class="py-op">)</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt class="py-name">ret</tt> </tt>
</div><a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line"> </tt>
<a name="resolve_srv"></a><div id="resolve_srv-def"><a name="L116"></a><tt class="py-lineno">116</tt> <a class="py-toggle" href="#" id="resolve_srv-toggle" onclick="return toggle('resolve_srv');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.resolver-module.html#resolve_srv">resolve_srv</a><tt class="py-op">(</tt><tt class="py-param">domain</tt><tt class="py-op">,</tt> <tt class="py-param">service</tt><tt class="py-op">,</tt> <tt class="py-param">proto</tt><tt class="py-op">=</tt><tt class="py-string">"tcp"</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="resolve_srv-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="resolve_srv-expanded"><a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line">    <tt class="py-docstring">"""Resolve service domain to server name and port number using SRV records.</tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line"><tt class="py-docstring">    A built-in service alias table will be used to lookup also some obsolete</tt> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line"><tt class="py-docstring">    record names.</tt> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line"><tt class="py-docstring">        - `domain`: domain name.</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line"><tt class="py-docstring">        - `service`: service name.</tt> </tt>
<a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line"><tt class="py-docstring">        - `proto`: protocol name.</tt> </tt>
<a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line"><tt class="py-docstring">        - `domain`: `unicode` or `str`</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line"><tt class="py-docstring">        - `service`: `unicode` or `str`</tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line"><tt class="py-docstring">        - `proto`: `str`</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line"><tt class="py-docstring">    :return: host names and port numbers for the service or None.</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line"><tt class="py-docstring">    :returntype: `list` of (`str`,`int`)"""</tt> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line">    <tt class="py-name">names_to_try</tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-string">u"_%s._%s.%s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">service</tt><tt class="py-op">,</tt><tt class="py-name">proto</tt><tt class="py-op">,</tt><tt id="link-22" class="py-name" targets="Variable pyxmpp.jid.JID.domain=pyxmpp.jid.JID-class.html#domain"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-22', 'domain', 'link-22');">domain</a></tt><tt class="py-op">)</tt><tt class="py-op">]</tt> </tt>
<a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt id="link-23" class="py-name"><a title="pyxmpp.resolver.service_aliases" class="py-name" href="#" onclick="return doclink('link-23', 'service_aliases', 'link-16');">service_aliases</a></tt><tt class="py-op">.</tt><tt class="py-name">has_key</tt><tt class="py-op">(</tt><tt class="py-name">service</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">a</tt> <tt class="py-keyword">in</tt> <tt id="link-24" class="py-name"><a title="pyxmpp.resolver.service_aliases" class="py-name" href="#" onclick="return doclink('link-24', 'service_aliases', 'link-16');">service_aliases</a></tt><tt class="py-op">[</tt><tt class="py-name">service</tt><tt class="py-op">]</tt><tt class="py-op">:</tt> </tt>
<a name="L136"></a><tt class="py-lineno">136</tt>  <tt class="py-line">            <tt class="py-name">names_to_try</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-string">u"_%s._%s.%s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">a</tt><tt class="py-op">,</tt><tt class="py-name">proto</tt><tt class="py-op">,</tt><tt id="link-25" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-25', 'domain', 'link-22');">domain</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line">    <tt class="py-keyword">for</tt> <tt id="link-26" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-26', 'name', 'link-3');">name</a></tt> <tt class="py-keyword">in</tt> <tt class="py-name">names_to_try</tt><tt class="py-op">:</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt id="link-27" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-27', 'name', 'link-3');">name</a></tt><tt class="py-op">,</tt> <tt class="py-name">unicode</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line">            <tt id="link-28" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-28', 'name', 'link-3');">name</a></tt> <tt class="py-op">=</tt> <tt id="link-29" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-29', 'name', 'link-3');">name</a></tt><tt class="py-op">.</tt><tt class="py-name">encode</tt><tt class="py-op">(</tt><tt class="py-string">"idna"</tt><tt class="py-op">)</tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line">            <tt class="py-name">r</tt> <tt class="py-op">=</tt> <tt class="py-name">dns</tt><tt class="py-op">.</tt><tt id="link-30" class="py-name"><a title="pyxmpp.resolver" class="py-name" href="#" onclick="return doclink('link-30', 'resolver', 'link-2');">resolver</a></tt><tt class="py-op">.</tt><tt class="py-name">query</tt><tt class="py-op">(</tt><tt id="link-31" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-31', 'name', 'link-3');">name</a></tt><tt class="py-op">,</tt> <tt class="py-string">'SRV'</tt><tt class="py-op">)</tt> </tt>
<a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt> <tt class="py-name">dns</tt><tt class="py-op">.</tt><tt class="py-name">exception</tt><tt class="py-op">.</tt><tt class="py-name">DNSException</tt><tt class="py-op">,</tt> <tt class="py-name">err</tt><tt class="py-op">:</tt> </tt>
<a name="L143"></a><tt class="py-lineno">143</tt>  <tt class="py-line">            <tt id="link-32" class="py-name"><a title="pyxmpp.resolver.logger
pyxmpp.xmlextra.logger" class="py-name" href="#" onclick="return doclink('link-32', 'logger', 'link-7');">logger</a></tt><tt class="py-op">.</tt><tt id="link-33" class="py-name" targets="Method pyxmpp.xmlextra.StreamHandler.warning()=pyxmpp.xmlextra.StreamHandler-class.html#warning,Method pyxmpp.xmlextra._SAXCallback.warning()=pyxmpp.xmlextra._SAXCallback-class.html#warning"><a title="pyxmpp.xmlextra.StreamHandler.warning
pyxmpp.xmlextra._SAXCallback.warning" class="py-name" href="#" onclick="return doclink('link-33', 'warning', 'link-33');">warning</a></tt><tt class="py-op">(</tt><tt class="py-string">"Could not resolve %r: %s"</tt><tt class="py-op">,</tt> <tt id="link-34" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-34', 'name', 'link-3');">name</a></tt><tt class="py-op">,</tt>  </tt>
<a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line">                                                    <tt class="py-name">err</tt><tt class="py-op">.</tt><tt class="py-name">__class__</tt><tt class="py-op">.</tt><tt id="link-35" class="py-name" targets="Variable pyxmpp.interfaces.IFeaturesProvider.__name__=pyxmpp.interfaces.IFeaturesProvider-class.html#__name__,Variable pyxmpp.interfaces.IIqHandlersProvider.__name__=pyxmpp.interfaces.IIqHandlersProvider-class.html#__name__,Variable pyxmpp.interfaces.IMessageHandlersProvider.__name__=pyxmpp.interfaces.IMessageHandlersProvider-class.html#__name__,Variable pyxmpp.interfaces.IPresenceHandlersProvider.__name__=pyxmpp.interfaces.IPresenceHandlersProvider-class.html#__name__,Variable pyxmpp.interfaces.IPyXMPPHelper.__name__=pyxmpp.interfaces.IPyXMPPHelper-class.html#__name__,Variable pyxmpp.interfaces.IStanzaHandlersProvider.__name__=pyxmpp.interfaces.IStanzaHandlersProvider-class.html#__name__,Variable zope.interface.Interface.__name__=zope.interface.Interface-class.html#__name__"><a title="pyxmpp.interfaces.IFeaturesProvider.__name__
pyxmpp.interfaces.IIqHandlersProvider.__name__
pyxmpp.interfaces.IMessageHandlersProvider.__name__
pyxmpp.interfaces.IPresenceHandlersProvider.__name__
pyxmpp.interfaces.IPyXMPPHelper.__name__
pyxmpp.interfaces.IStanzaHandlersProvider.__name__
zope.interface.Interface.__name__" class="py-name" href="#" onclick="return doclink('link-35', '__name__', 'link-35');">__name__</a></tt><tt class="py-op">)</tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line">            <tt class="py-keyword">continue</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">r</tt><tt class="py-op">:</tt> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line">            <tt class="py-keyword">continue</tt> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-op">[</tt><tt class="py-op">(</tt><tt class="py-name">rr</tt><tt class="py-op">.</tt><tt class="py-name">target</tt><tt class="py-op">.</tt><tt class="py-name">to_text</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">,</tt><tt class="py-name">rr</tt><tt class="py-op">.</tt><tt class="py-name">port</tt><tt class="py-op">)</tt> <tt class="py-keyword">for</tt> <tt class="py-name">rr</tt> <tt class="py-keyword">in</tt> <tt id="link-36" class="py-name" targets="Function pyxmpp.resolver.reorder_srv()=pyxmpp.resolver-module.html#reorder_srv"><a title="pyxmpp.resolver.reorder_srv" class="py-name" href="#" onclick="return doclink('link-36', 'reorder_srv', 'link-36');">reorder_srv</a></tt><tt class="py-op">(</tt><tt class="py-name">r</tt><tt class="py-op">)</tt><tt class="py-op">]</tt> </tt>
<a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt class="py-name">None</tt> </tt>
</div><a name="L150"></a><tt class="py-lineno">150</tt>  <tt class="py-line"> </tt>
<a name="getaddrinfo"></a><div id="getaddrinfo-def"><a name="L151"></a><tt class="py-lineno">151</tt> <a class="py-toggle" href="#" id="getaddrinfo-toggle" onclick="return toggle('getaddrinfo');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.resolver-module.html#getaddrinfo">getaddrinfo</a><tt class="py-op">(</tt><tt class="py-param">host</tt><tt class="py-op">,</tt> <tt class="py-param">port</tt><tt class="py-op">,</tt> <tt class="py-param">family</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">,</tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line">                <tt class="py-param">socktype</tt> <tt class="py-op">=</tt> <tt id="link-37" class="py-name"><a title="pyxmpp.jabberd.component.Component.socket" class="py-name" href="#" onclick="return doclink('link-37', 'socket', 'link-0');">socket</a></tt><tt class="py-op">.</tt><tt class="py-name">SOCK_STREAM</tt><tt class="py-op">,</tt> <tt class="py-param">proto</tt> <tt class="py-op">=</tt> <tt class="py-number">0</tt><tt class="py-op">,</tt> <tt class="py-param">allow_cname</tt> <tt class="py-op">=</tt> <tt class="py-name">True</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="getaddrinfo-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="getaddrinfo-expanded"><a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line">    <tt class="py-docstring">"""Resolve host and port into addrinfo struct.</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line"><tt class="py-docstring">    Does the same thing as socket.getaddrinfo, but using `dns.resolver`,</tt> </tt>
<a name="L156"></a><tt class="py-lineno">156</tt>  <tt class="py-line"><tt class="py-docstring">    so the cache content from the SRV query can be used.</tt> </tt>
<a name="L157"></a><tt class="py-lineno">157</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L159"></a><tt class="py-lineno">159</tt>  <tt class="py-line"><tt class="py-docstring">        - `host`: service domain name.</tt> </tt>
<a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line"><tt class="py-docstring">        - `port`: service port number or name.</tt> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line"><tt class="py-docstring">        - `family`: address family (`AF_INET` for IPv4, `AF_INET6` for IPv6 or</tt> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line"><tt class="py-docstring">          `AF_UNSPEC` for either, `None` for the auto-configured default).</tt> </tt>
<a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line"><tt class="py-docstring">        - `socktype`: socket type.</tt> </tt>
<a name="L164"></a><tt class="py-lineno">164</tt>  <tt class="py-line"><tt class="py-docstring">        - `proto`: protocol number or name.</tt> </tt>
<a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line"><tt class="py-docstring">        - `allow_cname`: when False CNAME responses are not allowed.</tt> </tt>
<a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line"><tt class="py-docstring">        - `host`: `unicode` or `str`</tt> </tt>
<a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line"><tt class="py-docstring">        - `port`: `int` or `str`</tt> </tt>
<a name="L169"></a><tt class="py-lineno">169</tt>  <tt class="py-line"><tt class="py-docstring">        - `family`: `int`</tt> </tt>
<a name="L170"></a><tt class="py-lineno">170</tt>  <tt class="py-line"><tt class="py-docstring">        - `socktype`: `int`</tt> </tt>
<a name="L171"></a><tt class="py-lineno">171</tt>  <tt class="py-line"><tt class="py-docstring">        - `proto`: `int` or `str`</tt> </tt>
<a name="L172"></a><tt class="py-lineno">172</tt>  <tt class="py-line"><tt class="py-docstring">        - `allow_cname`: `bool`</tt> </tt>
<a name="L173"></a><tt class="py-lineno">173</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L174"></a><tt class="py-lineno">174</tt>  <tt class="py-line"><tt class="py-docstring">    :return: list of (family, socktype, proto, canonname, sockaddr).</tt> </tt>
<a name="L175"></a><tt class="py-lineno">175</tt>  <tt class="py-line"><tt class="py-docstring">    :returntype: `list` of (`int`, `int`, `int`, `str`, (`str`, `int`))"""</tt> </tt>
<a name="L176"></a><tt class="py-lineno">176</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-name">family</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L177"></a><tt class="py-lineno">177</tt>  <tt class="py-line">        <tt class="py-name">family</tt> <tt class="py-op">=</tt> <tt id="link-38" class="py-name"><a title="pyxmpp.resolver.default_address_family" class="py-name" href="#" onclick="return doclink('link-38', 'default_address_family', 'link-12');">default_address_family</a></tt> </tt>
<a name="L178"></a><tt class="py-lineno">178</tt>  <tt class="py-line">    <tt class="py-name">ret</tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L179"></a><tt class="py-lineno">179</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-name">proto</tt><tt class="py-op">==</tt><tt class="py-number">0</tt><tt class="py-op">:</tt> </tt>
<a name="L180"></a><tt class="py-lineno">180</tt>  <tt class="py-line">        <tt class="py-name">proto</tt><tt class="py-op">=</tt><tt id="link-39" class="py-name"><a title="pyxmpp.jabberd.component.Component.socket" class="py-name" href="#" onclick="return doclink('link-39', 'socket', 'link-0');">socket</a></tt><tt class="py-op">.</tt><tt class="py-name">getprotobyname</tt><tt class="py-op">(</tt><tt class="py-string">"tcp"</tt><tt class="py-op">)</tt> </tt>
<a name="L181"></a><tt class="py-lineno">181</tt>  <tt class="py-line">    <tt class="py-keyword">elif</tt> <tt id="link-40" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoIdentity.type=pyxmpp.jabber.disco.DiscoIdentity-class.html#type"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-40', 'type', 'link-40');">type</a></tt><tt class="py-op">(</tt><tt class="py-name">proto</tt><tt class="py-op">)</tt><tt class="py-op">!=</tt><tt class="py-name">int</tt><tt class="py-op">:</tt> </tt>
<a name="L182"></a><tt class="py-lineno">182</tt>  <tt class="py-line">        <tt class="py-name">proto</tt><tt class="py-op">=</tt><tt id="link-41" class="py-name"><a title="pyxmpp.jabberd.component.Component.socket" class="py-name" href="#" onclick="return doclink('link-41', 'socket', 'link-0');">socket</a></tt><tt class="py-op">.</tt><tt class="py-name">getprotobyname</tt><tt class="py-op">(</tt><tt class="py-name">proto</tt><tt class="py-op">)</tt> </tt>
<a name="L183"></a><tt class="py-lineno">183</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt id="link-42" class="py-name"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-42', 'type', 'link-40');">type</a></tt><tt class="py-op">(</tt><tt class="py-name">port</tt><tt class="py-op">)</tt><tt class="py-op">!=</tt><tt class="py-name">int</tt><tt class="py-op">:</tt> </tt>
<a name="L184"></a><tt class="py-lineno">184</tt>  <tt class="py-line">        <tt class="py-name">port</tt><tt class="py-op">=</tt><tt id="link-43" class="py-name"><a title="pyxmpp.jabberd.component.Component.socket" class="py-name" href="#" onclick="return doclink('link-43', 'socket', 'link-0');">socket</a></tt><tt class="py-op">.</tt><tt class="py-name">getservbyname</tt><tt class="py-op">(</tt><tt class="py-name">port</tt><tt class="py-op">,</tt><tt class="py-name">proto</tt><tt class="py-op">)</tt> </tt>
<a name="L185"></a><tt class="py-lineno">185</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-name">family</tt> <tt class="py-keyword">not</tt> <tt class="py-keyword">in</tt> <tt class="py-op">(</tt><tt class="py-name">AF_UNSPEC</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET6</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L186"></a><tt class="py-lineno">186</tt>  <tt class="py-line">        <tt class="py-keyword">raise</tt> <tt class="py-name">NotImplementedError</tt><tt class="py-op">,</tt> <tt class="py-string">"Unsupported protocol family."</tt> </tt>
<a name="L187"></a><tt class="py-lineno">187</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt id="link-44" class="py-name"><a title="pyxmpp.resolver.ipv4_re" class="py-name" href="#" onclick="return doclink('link-44', 'ipv4_re', 'link-17');">ipv4_re</a></tt><tt class="py-op">.</tt><tt class="py-name">match</tt><tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">)</tt> <tt class="py-keyword">and</tt> <tt class="py-name">family</tt> <tt class="py-keyword">in</tt> <tt class="py-op">(</tt><tt class="py-name">AF_UNSPEC</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L188"></a><tt class="py-lineno">188</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-op">[</tt><tt class="py-op">(</tt><tt class="py-name">AF_INET</tt><tt class="py-op">,</tt> <tt class="py-name">socktype</tt><tt class="py-op">,</tt> <tt class="py-name">proto</tt><tt class="py-op">,</tt> <tt class="py-name">host</tt><tt class="py-op">,</tt> <tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">,</tt> <tt class="py-name">port</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">]</tt> </tt>
<a name="L189"></a><tt class="py-lineno">189</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt id="link-45" class="py-name"><a title="pyxmpp.resolver.ipv6_re" class="py-name" href="#" onclick="return doclink('link-45', 'ipv6_re', 'link-18');">ipv6_re</a></tt><tt class="py-op">.</tt><tt class="py-name">match</tt><tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">)</tt> <tt class="py-keyword">and</tt> <tt class="py-name">family</tt> <tt class="py-keyword">in</tt> <tt class="py-op">(</tt><tt class="py-name">AF_UNSPEC</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET6</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L190"></a><tt class="py-lineno">190</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-op">[</tt><tt class="py-op">(</tt><tt class="py-name">AF_INET6</tt><tt class="py-op">,</tt> <tt class="py-name">socktype</tt><tt class="py-op">,</tt> <tt class="py-name">proto</tt><tt class="py-op">,</tt> <tt class="py-name">host</tt><tt class="py-op">,</tt> <tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">,</tt> <tt class="py-name">port</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">]</tt> </tt>
<a name="L191"></a><tt class="py-lineno">191</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">,</tt> <tt class="py-name">unicode</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L192"></a><tt class="py-lineno">192</tt>  <tt class="py-line">        <tt class="py-name">host</tt> <tt class="py-op">=</tt> <tt class="py-name">host</tt><tt class="py-op">.</tt><tt class="py-name">encode</tt><tt class="py-op">(</tt><tt class="py-string">"idna"</tt><tt class="py-op">)</tt> </tt>
<a name="L193"></a><tt class="py-lineno">193</tt>  <tt class="py-line">    <tt class="py-name">rtypes</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L194"></a><tt class="py-lineno">194</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-name">family</tt> <tt class="py-keyword">in</tt> <tt class="py-op">(</tt><tt class="py-name">AF_UNSPEC</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET6</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L195"></a><tt class="py-lineno">195</tt>  <tt class="py-line">        <tt class="py-name">rtypes</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-op">(</tt><tt class="py-string">"AAAA"</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET6</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L196"></a><tt class="py-lineno">196</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-name">family</tt> <tt class="py-keyword">in</tt> <tt class="py-op">(</tt><tt class="py-name">AF_UNSPEC</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L197"></a><tt class="py-lineno">197</tt>  <tt class="py-line">        <tt class="py-name">rtypes</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-op">(</tt><tt class="py-string">"A"</tt><tt class="py-op">,</tt> <tt class="py-name">AF_INET</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L198"></a><tt class="py-lineno">198</tt>  <tt class="py-line">    <tt class="py-name">exception</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L199"></a><tt class="py-lineno">199</tt>  <tt class="py-line">    <tt class="py-keyword">for</tt> <tt class="py-name">rtype</tt><tt class="py-op">,</tt> <tt class="py-name">rfamily</tt> <tt class="py-keyword">in</tt> <tt class="py-name">rtypes</tt><tt class="py-op">:</tt> </tt>
<a name="L200"></a><tt class="py-lineno">200</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L201"></a><tt class="py-lineno">201</tt>  <tt class="py-line">            <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L202"></a><tt class="py-lineno">202</tt>  <tt class="py-line">                <tt class="py-name">r</tt><tt class="py-op">=</tt><tt class="py-name">dns</tt><tt class="py-op">.</tt><tt id="link-46" class="py-name"><a title="pyxmpp.resolver" class="py-name" href="#" onclick="return doclink('link-46', 'resolver', 'link-2');">resolver</a></tt><tt class="py-op">.</tt><tt class="py-name">query</tt><tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">,</tt> <tt class="py-name">rtype</tt><tt class="py-op">)</tt> </tt>
<a name="L203"></a><tt class="py-lineno">203</tt>  <tt class="py-line">            <tt class="py-keyword">except</tt> <tt class="py-name">dns</tt><tt class="py-op">.</tt><tt class="py-name">exception</tt><tt class="py-op">.</tt><tt class="py-name">DNSException</tt><tt class="py-op">:</tt> </tt>
<a name="L204"></a><tt class="py-lineno">204</tt>  <tt class="py-line">                <tt class="py-name">r</tt><tt class="py-op">=</tt><tt class="py-name">dns</tt><tt class="py-op">.</tt><tt id="link-47" class="py-name"><a title="pyxmpp.resolver" class="py-name" href="#" onclick="return doclink('link-47', 'resolver', 'link-2');">resolver</a></tt><tt class="py-op">.</tt><tt class="py-name">query</tt><tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">+</tt><tt class="py-string">"."</tt><tt class="py-op">,</tt> <tt class="py-name">rtype</tt><tt class="py-op">)</tt> </tt>
<a name="L205"></a><tt class="py-lineno">205</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt> <tt class="py-name">dns</tt><tt class="py-op">.</tt><tt class="py-name">exception</tt><tt class="py-op">.</tt><tt class="py-name">DNSException</tt><tt class="py-op">,</tt> <tt class="py-name">err</tt><tt class="py-op">:</tt> </tt>
<a name="L206"></a><tt class="py-lineno">206</tt>  <tt class="py-line">            <tt class="py-name">exception</tt> <tt class="py-op">=</tt> <tt class="py-name">err</tt> </tt>
<a name="L207"></a><tt class="py-lineno">207</tt>  <tt class="py-line">            <tt class="py-keyword">continue</tt> </tt>
<a name="L208"></a><tt class="py-lineno">208</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">allow_cname</tt> <tt class="py-keyword">and</tt> <tt class="py-name">r</tt><tt class="py-op">.</tt><tt class="py-name">rrset</tt><tt class="py-op">.</tt><tt id="link-48" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-48', 'name', 'link-3');">name</a></tt> <tt class="py-op">!=</tt> <tt class="py-name">dns</tt><tt class="py-op">.</tt><tt id="link-49" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-49', 'name', 'link-3');">name</a></tt><tt class="py-op">.</tt><tt class="py-name">from_text</tt><tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L209"></a><tt class="py-lineno">209</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt id="link-50" class="py-name"><a title="pyxmpp.exceptions.UnexpectedCNAMEError" class="py-name" href="#" onclick="return doclink('link-50', 'UnexpectedCNAMEError', 'link-6');">UnexpectedCNAMEError</a></tt><tt class="py-op">,</tt> <tt class="py-op">(</tt> </tt>
<a name="L210"></a><tt class="py-lineno">210</tt>  <tt class="py-line">                    <tt class="py-string">"Unexpected CNAME record found for %r"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">,</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L211"></a><tt class="py-lineno">211</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">r</tt><tt class="py-op">:</tt> </tt>
<a name="L212"></a><tt class="py-lineno">212</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt class="py-name">rr</tt> <tt class="py-keyword">in</tt> <tt class="py-name">r</tt><tt class="py-op">:</tt> </tt>
<a name="L213"></a><tt class="py-lineno">213</tt>  <tt class="py-line">                <tt class="py-name">ret</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-op">(</tt><tt class="py-name">rfamily</tt><tt class="py-op">,</tt> <tt class="py-name">socktype</tt><tt class="py-op">,</tt> <tt class="py-name">proto</tt><tt class="py-op">,</tt> <tt class="py-name">r</tt><tt class="py-op">.</tt><tt class="py-name">rrset</tt><tt class="py-op">.</tt><tt id="link-51" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-51', 'name', 'link-3');">name</a></tt><tt class="py-op">,</tt> </tt>
<a name="L214"></a><tt class="py-lineno">214</tt>  <tt class="py-line">                                                        <tt class="py-op">(</tt><tt class="py-name">rr</tt><tt class="py-op">.</tt><tt class="py-name">to_text</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">,</tt><tt class="py-name">port</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L215"></a><tt class="py-lineno">215</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">ret</tt> <tt class="py-keyword">and</tt> <tt class="py-name">exception</tt><tt class="py-op">:</tt> </tt>
<a name="L216"></a><tt class="py-lineno">216</tt>  <tt class="py-line">        <tt class="py-keyword">raise</tt> <tt id="link-52" class="py-name"><a title="pyxmpp.exceptions.DNSError" class="py-name" href="#" onclick="return doclink('link-52', 'DNSError', 'link-5');">DNSError</a></tt><tt class="py-op">,</tt> <tt class="py-string">"Could not resolve %r: %s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">host</tt><tt class="py-op">,</tt> </tt>
<a name="L217"></a><tt class="py-lineno">217</tt>  <tt class="py-line">                                                <tt class="py-name">exception</tt><tt class="py-op">.</tt><tt class="py-name">__class__</tt><tt class="py-op">.</tt><tt id="link-53" class="py-name"><a title="pyxmpp.interfaces.IFeaturesProvider.__name__
pyxmpp.interfaces.IIqHandlersProvider.__name__
pyxmpp.interfaces.IMessageHandlersProvider.__name__
pyxmpp.interfaces.IPresenceHandlersProvider.__name__
pyxmpp.interfaces.IPyXMPPHelper.__name__
pyxmpp.interfaces.IStanzaHandlersProvider.__name__
zope.interface.Interface.__name__" class="py-name" href="#" onclick="return doclink('link-53', '__name__', 'link-35');">__name__</a></tt><tt class="py-op">)</tt> </tt>
<a name="L218"></a><tt class="py-lineno">218</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt class="py-name">ret</tt> </tt>
</div><a name="L219"></a><tt class="py-lineno">219</tt>  <tt class="py-line"> </tt>
<a name="L220"></a><tt class="py-lineno">220</tt>  <tt class="py-line"><tt class="py-comment"># vi: sts=4 et sw=4</tt> </tt>
<a name="L221"></a><tt class="py-lineno">221</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:06 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
